# Magento 2 modulo per l'integrazione con PSV

## Installation
- Add the VCS repository to composer:
```sh
$ composer config repositories.drop.pvs vcs git@bitbucket.org:dropsrl/drop-module-pvs.git
```

- Add the module to composer:
```sh
$ composer require drop/module-pvs
```

- Enable module, install and clear magento cache
```sh
$ bin/magento module:enable Drop_Pvs
$ bin/magento module:enable setup:upgrade
$ bin/magento module:enable cache:clear
```

## Description

- Creazione pdf fattura e salvataggio FTP (credenziali da indicare)
- Lettura da FTP e gestione ordini annullati/articoli non vendibili
- Rimborso automatico per ordini annullati tramite Api Adyen
- Comunicazione resi tramite FTP
- Lettura da FTP e gestione resi ricevuti
- Rimborso automatico per resi totali tramite Api Adyen


## Requirements
- PHP >= 7.0.0
- Rcason_Mq
- Drop_Pdfgenerator
- adyen/php-api-library
- league/flysystem-sftp

## Compatibility
- Magento >= 2.2
- Not tested on 2.1 and 2.0

## Support
If you encounter any problems or bugs, please contact us [here](https://www.drop.it) or create an issue.

## Developer
Alberto Pallotto (a.pallotto@drop.it)